#ifndef XMLRPC_PARSE_H
#define XMLRPC_PARSE_H

struct xmlrpc_struct_i4_or_str
{
    char *name;
    union {
        int i4;
        char *str;
    } value;
};

#define STRUCT_PARSE(resp, maxfld) struct xmlrpc_struct_i4_or_str gas[maxfld]; int nitms = xmlrpc_response(resp, gas); for(int i = 0; i < nitms; i++)
#define RECFLD(type, target, field) if(strcmp(gas[i].name, #field) == 0) target.field = gas[i].value.type;

int xmlrpc_response(const char *xmlstr, void *res);
int xmlrpc_response_status(const char *xmlstr);
int xmlrpc_response_errmsg(const char *xmlstr, int *errcod, char **errmsg);

void *xmlrpc_struct_init(const char *xmlstr, int nfld);
int xmlrpc_struct_n(void *ctx);
int xmlrpc_struct_unpack_i4(void *ctx, int ix, const char *name);
char *xmlrpc_struct_unpack_string(void *ctx, int ix, const char *name);
void xmlrpc_struct_cleanup(void *ctx);

#endif
